package ru.littlevictor.radio;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;

public class DynamicListAdapter extends ArrayAdapter<String> {

    final int INVALID_ID = -1;
    private LayoutInflater lInflater;

    HashMap<String, Integer> mIdMap = new HashMap<String, Integer>();

    public DynamicListAdapter(Context context, ArrayList<String> index) {
        super(context, 0, index);
        lInflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        for (int i = 0; i < index.size(); i++) {
            mIdMap.put(index.get(i), i);
        }
    };

    @Override
    public long getItemId(int position) {
        if (position < 0 || position >= mIdMap.size()) {
            return INVALID_ID;
        }
        String item = getItem(position);
        return mIdMap.get(item);
    };

    @Override
    public boolean hasStableIds() {
        return true;
    };

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = lInflater.inflate(R.layout.radio_edit_two_line_cell, parent, false);
        }
        ((TextView) convertView.findViewById(R.id.text1)).setText(RadioEdit.data.names.get(position));
        ((TextView) convertView.findViewById(R.id.text2)).setText(RadioEdit.data.urls.get(position));
        ImageView dragImg = (ImageView) convertView.findViewById(R.id.drag_image);
        dragImg.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if ((event.getAction() & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_DOWN) DynamicListView.dragIsOn = true;
                return false;
            };
        });
        if ((position % 2) == 0 ) {
            convertView.setBackgroundResource(R.drawable.background_activated_list_odd);
        } else {
            convertView.setBackgroundResource(R.drawable.background_activated_list_even);
        }
        return convertView;
    };
};
