package ru.littlevictor.radio;

import java.io.File;

import android.content.Context;

public class Storage {
	
	public static final int MAIN_LIST = 0;
	public static final int TMP_DIR = 1;
	public static final int LIST_STACK = 2;
	
	public static String getPath(Context context, int list) {
		if(!context.getFilesDir().canRead()) context.getFilesDir().mkdir();
		switch(list) {
		case MAIN_LIST:
			return context.getFilesDir().toString() + "/main.m3u";
		case TMP_DIR:
			return context.getCacheDir().toString() + "/";
		case LIST_STACK:
			return context.getCacheDir().toString() + "/list_stack.ser";
		};
		return null;
	};
	
	public static boolean clearCache(Context context) {
        String[] children = context.getCacheDir().list();
        for (int i = 0; i < children.length; i++) {
        	String name = children[i];
        	File file = new File(context.getCacheDir().toString() + "/" + name);
        	if(file.isDirectory() || name.contains("com.android")) continue;
            boolean success = file.delete();
            if (!success) {
                return false;
            }
        }
	    return true;
	};
};
