package ru.littlevictor.radio;

import java.util.ArrayList;

import android.content.Context;
import android.content.Intent;
import android.widget.RemoteViews;
import android.widget.RemoteViewsService.RemoteViewsFactory;

// -----------------------------------------------------------------------------
public class WidgetFactory implements RemoteViewsFactory {

	private ArrayList<String> names;
	private Context context;
	private int currentPosition = 0;
	private int rViewLayoutId;
	private int selectedBgColor;

	// -----------------------------------------------------------------------------
	WidgetFactory(Context context, Intent intent) {
		this.context = context;
	};

	// -----------------------------------------------------------------------------
	@Override
	public void onCreate() {
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public int getCount() {
	    try 
	    {
			return names.size();
	    }
	    catch (Exception e) 
	    {
            return 0;
	    }
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public long getItemId(int position) {
		return position;
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public RemoteViews getLoadingView() {
		return null;
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public RemoteViews getViewAt(int position) {
		RemoteViews rView = new RemoteViews(context.getPackageName(), rViewLayoutId);
	    try 
	    {
			rView.setTextViewText(R.id.text1, names.get(position));
			if(currentPosition == position) {
				rView.setInt(R.id.text1, "setBackgroundColor", selectedBgColor);
			} else {
				rView.setInt(R.id.text1, "setBackgroundColor", context.getResources().getColor(android.R.color.transparent));
			};
		    Intent clickIntent = new Intent();
		    clickIntent.putExtra(context.getResources().getString(R.string.widget_item_position), position);
		    rView.setOnClickFillInIntent(R.id.text1, clickIntent);
	    }
	    catch (Exception e) 
	    {
			Intent intent = new Intent(context, RadioService.class)
			.putExtra(context.getResources().getString(R.string.service_state), RadioService.STATE);
			context.startService(intent);
	    }
		return rView;
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public int getViewTypeCount() {
		return 1;
	};
	
	// -----------------------------------------------------------------------------
	@Override
	public boolean hasStableIds() {
		return true;
	};

	// -----------------------------------------------------------------------------
	@Override
	public void onDataSetChanged() {
	    try 
	    {
			currentPosition = WidgetMain.currentPosition;
			names = WidgetMain.names;
			String appTheme = WidgetMain.theme;
			if (appTheme.equalsIgnoreCase("0")) {
				rViewLayoutId = R.layout.widget_main_cell_light;
				selectedBgColor = context.getResources().getColor(R.color.color_background_primary_light_selected);
			} else if (appTheme.equalsIgnoreCase("1")) {
				rViewLayoutId = R.layout.widget_main_cell_dark;
				selectedBgColor = context.getResources().getColor(R.color.color_background_primary_dark_selected);
			} else {
				rViewLayoutId = R.layout.widget_main_cell_light;
				selectedBgColor = context.getResources().getColor(R.color.color_background_primary_light_selected);
			};
	    }
	    catch (Exception e) 
	    {
			Intent intent = new Intent(context, RadioService.class)
			.putExtra(context.getResources().getString(R.string.service_state), RadioService.STATE);
			context.startService(intent);
	    };
	};

	// -----------------------------------------------------------------------------
	@Override
	public void onDestroy() {
		
	};
	
	// -----------------------------------------------------------------------------
};